/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "adc.h"

/******************************************************************************
* Macros
******************************************************************************/


/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/

//get the result from ADC
volatile uint16_t ADCresult;
volatile uint8_t ADC_Ready;

/******************************************************************************
* Local Function Declarations
******************************************************************************/


/******************************************************************************
* Local Function Definitions
******************************************************************************/


/******************************************************************************
* Global Function Definitions
******************************************************************************/

/******************************************************************************
* Function:         void ADC_Init(void)
* Description:		AD inicializlsa
* Input:
* Output:
* Notes:
******************************************************************************/
void ADC_Init(void)
{
	//------------------ ADC ----------------------------
	//          D7     D6     D5     D4     D3     D2     D1   D0
	//ADMUX: REFS1   REFS0  ADLAR   MUX4   MUX3   MUX2   MUX1 MUX0
	//           0      0      0      0      0     0      0     0
	//Vref: AVcc, Input: ADC0, No Gain, right justified
	ADMUX = 0;
	//          D7     D6     D5     D4     D3     D2     D1    D0
	//ADCSRA: ADEN   ADSC   ADATE   ADIF   ADIE   ADPS2  ADPS1 ADPS0
	//          1      1      1      0      1     1      1      1
	ADCSRA = (1 << ADEN) | (1 << ADSC) | (1 << ADATE) | (1 << ADIE) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
	//AD enable, AD start, Auto trigger free run, IT enable
	//          D7     D6     D5     D4     D3     D2     D1    D0
	//ADCSRB:    -   ACME     -       -     -     ADTS2  ADTS1 ADTS0
	//          0      0      0      0      0     0      0      0
	ADCSRB = 0;
	ADC_Ready = 0;
}



/******************************************************************************
* Interrupt Routines
******************************************************************************/


/******************************************************************************
* Function:         ISR(SIG_ADC)
* Description:		AD megszaktsa
* Input:
* Output:
* Notes:
******************************************************************************/
ISR(SIG_ADC)
{
	ADCresult = ADC;
	ADC_Ready = 1;
}